/*
 * 쐬: 2004/02/22
 *
 * ̐ꂽRg̑}ev[gύX邽
 * EBhE > ݒ > Java > R[h > R[hƃRg
 */
package org.jpn.xucker.html;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import javax.xml.transform.TransformerFactoryConfigurationError;

import org.cyberneko.html.parsers.DOMParser;
import org.jpn.xucker.io.PathnameUtils;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

/**
 * @author 
 *
 * ̐ꂽRg̑}ev[gύX邽
 * EBhE > ݒ > Java > R[h > R[hƃRg
 */
public class LinkChanger {
	private String rootDir;
	private Hashtable finishList = new Hashtable();
	private List errorList = new Vector();
	private String indexFile = "index.html";
	DOMParser domParser;
	Document document;
	
	private String[] ignoreExtensions;
	public LinkChanger() {
		ignoreExtensions = new String[] { ".cgi" };
		domParser= new DOMParser();
	}
	
	private Map linkTmpHash;
	public void doCheck(File file) {
		if (System.getProperty("debug") != null)
			System.out.println("check:" + file.getAbsolutePath());

		

		try {
			try {
				domParser.parse(
					new InputSource(
						new InputStreamReader(
							new FileInputStream(file),
							"MS932")));
			} catch (SAXException e1) {
				// TODO ꂽ catch ubN
				e1.printStackTrace();
			}
			document = domParser.getDocument();

			NodeList list = document.getElementsByTagName("a");
			int length = list.getLength();

			
			linkTmpHash=new Hashtable();
			
			for (int i = 0; i < length; i++) {
				Element element = (Element) list.item(i);
				String href=element.getAttribute("href");
				if(href!=null && !href.equals("")){
					linkTmpHash.put(href,"");
				}
			}
			String hrefs[]=(String[])linkTmpHash.keySet().toArray(new String[0]);
			for(int i=0;i<hrefs.length;i++){
				testAtag(file, hrefs[i]);	
			}
			

			linkTmpHash=new Hashtable();
			NodeList imageList = document.getElementsByTagName("img");
			int imageList_length = imageList.getLength();

			for (int i = 0; i < imageList_length; i++) {
				Element element = (Element) imageList.item(i);
				String src=element.getAttribute("src");
								if(src!=null && !src.equals("")){
									linkTmpHash.put(src,"");
								}
				//testImagetag(file, element);
			}

			String srcs[]=(String[])linkTmpHash.keySet().toArray(new String[0]);
						for(int i=0;i<srcs.length;i++){
							testImagetag(file, srcs[i]);	
						}
			
			//check A
		} catch (TransformerFactoryConfigurationError e) {
			System.err.println("Configuration Error : " + e.getMessage());
		} catch (IOException e) {
			System.err.println("Exception : " + e.getMessage());
		}
	}

	/**
	 * @param element
	 */
	public boolean isGlobalResource(String path){
		if(path.startsWith("http://")){
			return true;
		}
		if(path.startsWith("https://")){
					return true;
				}
		if(path.startsWith("mailto:")){
			return true;
		}
		if(path.startsWith("ftp:")){
			return true;
		}
		return false;
	}

	private void testAtag(File baseFile, String href) {
		//String href = element.getAttribute("href");

		if (href != null && !href.equals("")) {
			String basePath = toPath(baseFile);
			String nonquery = PathnameUtils.getNonQueryAnchorPath(href);
			if(isGlobalResource(nonquery)){
				testGlobalPath(basePath,nonquery);
			}else{
				testLocalPath(basePath,nonquery);
			}

		}

	}

	/**
	 * @param basePath
	 * @param href
	 */
	private void testLocalPath(String basePath, String href) {
	
					File linkFile = linkToFile(basePath, href);
		if (System.getProperty("debug") != null)
					System.out.println("check-file:" +linkFile+" from "+ basePath);

					if (linkFile == null) {
						System.out.println("create path faild "+basePath + ":" + href);
					} else {

						if (!isFinishTest(linkFile)) {
							if (isExistFile(linkFile)) {
								startTest(linkFile);
							} else {
								doError(linkFile,basePath,href);
							}
						}
					}
		
	}
	
	private void testGlobalPath(String basePath, String href) {
		//decoy for PMD
		String tmp=basePath;
		tmp=href;
		
		}
	/**
	 * @param linkFile
	 * @param basePath
	 * @param href
	 */
	private void doError(File linkFile, String basePath, String href) {
		if (!isIgnoreError(linkFile))
							addError(basePath, href);
	}
	
	/**
	 * @param linkFile
	 */
	private void startTest(File linkFile) {
		addFinishList(linkFile);
		if (isHtml(linkFile)) {
			doCheck(linkFile);
		}
	}
	/**
	 * @param linkFile
	 * @return
	 */
	private boolean isExistFile(File linkFile) {
		if (linkFile.isFile()) {
			//System.out.println(linkFile);
			return true;
		} else if (linkFile.isDirectory()) {
			//never happn. becouse linkToFile methods change
			throw new RuntimeException("directory never call");
			/*
			File tmpFile=new File(linkFile,indexFile);
			if(tmpFile.exists())
				return true;
			else
				return false;*/
		}
		return false;
	}
	private void testImagetag(File baseFile, String src) {

	//	String src = element.getAttribute("src");
		if (src != null && !src.equals("")) {
			String basePath = toPath(baseFile);
			if(!isGlobalResource(src)){
										File linkFile = linkToFile(basePath, src);
			
			if (System.getProperty("debug") != null)
				System.out.println("check-image:" + linkFile.getAbsolutePath()+" from "+baseFile.getAbsolutePath());
			if (linkFile == null) {
				System.out.println(basePath + ":" + src);
			} else {

				if (!isFinishTest(linkFile)) {
					if (!linkFile.exists()) {
						if (!isIgnoreError(linkFile))
							addError(basePath, src);
					} else {
						addFinishList(linkFile);

					}
				}
			}
			}

		}

	}

	/**
	 * @param linkFile
	 * @return
	 */
	private boolean isIgnoreError(File linkFile) {
		//query

		if (ignoreExtensions != null) {
			for (int i = 0; i < ignoreExtensions.length; i++) {
				if (linkFile
					.getName()
					.toLowerCase()
					.endsWith(ignoreExtensions[i]))
					return true;
			}
		}

		// TODO ꂽ\bhEX^u
		return false;
	}

	/**
	 * @param linkFile
	 * @return
	 */
	private boolean isHtml(File linkFile) {
		String htmls[] = { ".html", ".htm", ".shtml" };

		for (int i = 0; i < htmls.length; i++) {
			if (linkFile.getName().toLowerCase().endsWith(htmls[i]))
				return true;
		}
		return false;
	}

	/**
	 * @param linkFile
	 */
	private void addFinishList(File linkFile) {
		finishList.put(linkFile.getAbsolutePath(), "");
	}

	/**
	 * @param linkFile
	 * @return
	 */
	private boolean isFinishTest(File linkFile) {
		return finishList.get(linkFile.getAbsolutePath()) != null;
	}

	/**
	 * @param basePath
	 * @param href
	 */
	private void addError(String basePath, String href) {
		HtmlError err = new HtmlError(basePath, href);
		errorList.add(err);
	}

	public HtmlError[] getErrors() {
		return (HtmlError[]) errorList.toArray(new HtmlError[errorList.size()]);
	}

	public File linkToFile(String base, String path) {
		if (path.equals(""))
			return new File(rootDir, base);
		File result = null;

		URL url;
		try {
			url = new URL("http://" + getCurrentHost());

			url = new URL(url, base);
			url = new URL(url, path);
			if (!url.getHost().equals(getCurrentHost())) {
				result = null;
			} else {
				result = new File(rootDir, fixPath(url.getPath()));
				if (result.exists() && result.isDirectory()) {
					result = new File(result, getIndexFile());
				}
			}

		} catch (MalformedURLException e) {
			// TODO ꂽ catch ubN
			e.printStackTrace();
		}
		return result;

	}

	/**
	 * @param string
	 */
	private String fixPath(String string) {
		String result = string;
		result = result.replaceAll("\\.\\./", "");
		result = result.replaceAll("\\./", "");
		return result;
	}

	/**
	 * @return
	 */
	private String getCurrentHost() {
		// TODO ꂽ\bhEX^u
		return "localhost";
	}

	private String toPath(File file) {
		File rootFile = new File(rootDir);

		if (file.getAbsolutePath().startsWith(rootFile.getAbsolutePath())) {
			String path =
				file.getAbsolutePath().substring(
					rootFile.getAbsolutePath().length());
			if (!path.equals("\\") && file.isDirectory())
				path += "/";
			return path.replaceAll("\\\\", "/");
		} else {
			return "";
		}
	}

	public static void main(String[] args) {
		LinkChanger tester = new LinkChanger();
		tester.setRootDir(args[0]);
		tester.doCheck(new File(args[1]));
		HtmlError[] errors = tester.getErrors();
		for (int i = 0; i < errors.length; i++) {
			System.out.println(
				"not found:"
					+ errors[i].getBaseHref()
					+ " "
					+ errors[i].getLinkHref());
		}
	}
	/**
	 * @return
	 */
	public String getRootDir() {
		return rootDir;
	}

	/**
	 * @param string
	 */
	public void setRootDir(String string) {
		rootDir = string;
	}

	/**
	 * @return
	 */
	public String[] getIgnoreExtensions() {
		return ignoreExtensions;
	}

	/**
	 * @param strings
	 */
	public void setIgnoreExtensions(String[] strings) {
		ignoreExtensions = strings;
	}

	/**
	 * @return
	 */
	public String getIndexFile() {
		return indexFile;
	}

	/**
	 * @param string
	 */
	public void setIndexFile(String string) {
		indexFile = string;
	}

}
